Package: org.codehaus.groovy.ast

## [Java] Class InnerClassNode

- org.codehaus.groovy.ast.InnerClassNode

-     public class InnerClassNode
      extends ClassNode

  Represents an inner class declaration

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class ClassNode` | `EMPTY_ARRAY, SUPER, THIS, clazz, innerClasses, isPrimaryNode, lazyInitLock`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `InnerClassNode (ClassNode outerClass, String name, int modifiers, ClassNode superClass)` Parameters: `name` - is the full name of the class
    `InnerClassNode (ClassNode outerClass, String name, int modifiers, ClassNode superClass, ClassNode[] interfaces, MixinNode[] mixins)` Parameters: `name` - is the full name of the class

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `addConstructor(ConstructorNode node)`
    `` | `public ConstructorNode` | `addConstructor(int modifiers, Parameter[] parameters, ClassNode[] exceptions, Statement code)`
    `` | `public ClassNode` | `getOuterClass()`
    `` | `public FieldNode` | `getOuterField(String name)` Returns: the field node on the outer class or null if this is not an inner class
    `` | `public ClassNode` | `getOuterMostClass()`
    `` | `public VariableScope` | `getVariableScope()`
    `` | `public boolean` | `isAnonymous()`
    `` | `public void` | `setAnonymous(boolean anonymous)`
    `` | `public void` | `setVariableScope(VariableScope scope)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassNode` | `addConstructor, addConstructor, addField, addField, addFieldFirst, addFieldFirst, addInterface, addMethod, addMethod, addMixin, addObjectInitializerStatements, addProperty, addProperty, addStaticInitializerStatements, addSyntheticMethod, addTransform, asGenericsType, declaresAnyInterfaces, declaresInterface, equals, getAbstractMethods, getAllDeclaredMethods, getAllInterfaces, getAnnotations, getAnnotations, getCompileUnit, getComponentType, getDeclaredConstructor, getDeclaredConstructors, getDeclaredField, getDeclaredMethod, getDeclaredMethods, getDeclaredMethodsMap, getEnclosingMethod, getField, getFieldIndex, getFields, getGenericsTypes, getGetterMethod, getGetterMethod, getInnerClasses, getInterfaces, getMethod, getMethods, getMethods, getMixins, getModifiers, getModule, getName, getNameWithoutPackage, getObjectInitializerStatements, getOuterClass, getOuterClasses, getOuterField, getPackage, getPackageName, getPlainNodeReference, getProperties, getProperty, getSetterMethod, getSetterMethod, getSuperClass, getText, getTransforms, getTypeClass, getUnresolvedInterfaces, getUnresolvedInterfaces, getUnresolvedName, getUnresolvedSuperClass, getUnresolvedSuperClass, hasDeclaredMethod, hasMethod, hasPackageName, hasPossibleMethod, hasPossibleStaticMethod, hasProperty, hashCode, implementsAnyInterfaces, implementsInterface, isAbstract, isAnnotated, isAnnotationDefinition, isArray, isDerivedFrom, isDerivedFromGroovyObject, isEnum, isGenericsPlaceHolder, isInterface, isPrimaryClassNode, isRedirectNode, isResolved, isScript, isScriptBody, isStaticClass, isSyntheticPublic, isUsingGenerics, makeArray, parametersEqual, positionStmtsAfterEnumInitStmts, redirect, removeConstructor, removeField, removeMethod, renameField, setAnnotated, setCompileUnit, setEnclosingMethod, setGenericsPlaceHolder, setGenericsTypes, setInterfaces, setMixins, setModifiers, setModule, setName, setRedirect, setScript, setScriptBody, setStaticClass, setSuperClass, setSyntheticPublic, setUnresolvedSuperClass, setUsingGenerics, toString, toString, tryFindPossibleMethod, visitContents`
    `class AnnotatedNode` | `addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`
    `class ASTNode` | `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, getText, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition, visit`

- - ### Constructor Detail

    - #### public InnerClassNode(ClassNode outerClass, String name, int modifiers, ClassNode superClass)

      Parameters:
        `name` - is the full name of the class
        `modifiers` - the modifiers,
        `superClass` - the base class name - use "java.lang.Object" if no direct base class
      See Also:
        org.objectweb.asm.Opcodes

    - #### public InnerClassNode(ClassNode outerClass, String name, int modifiers, ClassNode superClass, ClassNode[] interfaces, MixinNode[] mixins)

      Parameters:
        `name` - is the full name of the class
        `modifiers` - the modifiers,
        `superClass` - the base class name - use "java.lang.Object" if no direct base class
      See Also:
        org.objectweb.asm.Opcodes

  - ### Method Detail

    - #### @Override public void addConstructor(ConstructorNode node)

    - #### @Override public ConstructorNode addConstructor(int modifiers, Parameter[] parameters, ClassNode[] exceptions, Statement code)

    - #### public ClassNode getOuterClass()

    - #### public FieldNode getOuterField(String name)

      Returns:
        the field node on the outer class or null if this is not an inner class

    - #### public ClassNode getOuterMostClass()

    - #### public VariableScope getVariableScope()

    - #### public boolean isAnonymous()

    - #### public void setAnonymous(boolean anonymous)

    - #### public void setVariableScope(VariableScope scope)